#!/usr/bin/python

##############################################################
# 
#                       Fantastik	 	             #
#
# Python Extension for changing background interactivel
# Author: Andreas Brandmaier (andy@brandmaier.de)
# License:  GPL
#                                                           
##############################################################


import karamba


# backgroundimage

backgroundlist = ["bg_clean2.png", "bg_clean.png","crystal-liquid.png","crystal-grey.png","kavolo.png","simple.png"]
backgroundlistindex = 0


#this is called when you widget is initialized
def initWidget(widget):
	readConfiguration(widget)
	
	createConfigurationMenu(widget)

	updateLayout(widget)	

def createConfigurationMenu(widget):
		
	karamba.addMenuConfigOption(widget, "background", "Change background")
	mySetMenuConfigOption(widget, "background", 0)	


def menuOptionChanged(widget, key, value):

	global  menu_changebackground_id

	if key == "background":

		mySetMenuConfigOption(widget, "background", 0)
		cl = ["kdialog", "--title", "", "--radiolist", ""]
		for i in range(len(backgroundlist)):
			cl.append(str(i))
			cl.append(backgroundlist[i])
			cl.append("off")
		menu_changebackground_id = karamba.executeInteractive(widget, cl)	



def commandOutput(widget, pid, output):

	global menu_changebackground_id
	global backgroundlistindex

        if pid == menu_changebackground_id:
                rnr = int(output)
                backgroundlistindex = rnr
                updateLayout(widget)

	writeConfiguration(widget)


def writeConfiguration(widget):
        global backgroundlistindex
        karamba.writeConfigEntry(widget, "backgroundimage", str(backgroundlistindex) )	


def readConfiguration(widget):
	global backgroundlistindex
      	try:
		backgroundlistindex =  int(karamba.readConfigEntry(widget, "backgroundimage"))
	except:
	        print "Backgroundindex not valid - using default"
                backgroundlistindex = 0

def updateLayout(widget):

	# background

	background = karamba.getThemeImage(widget, "background")	
	karamba.setImagePath(widget, background, "image/"+backgroundlist[backgroundlistindex])

	print "load image:   image/"+backgroundlist[backgroundlistindex]

## Workaround

def mySetMenuConfigOption(widget, key, value):

	try:
		karamba.setMenuConfigOption(widget, key, value)
	except:
		karamba.setMenuConfigOption(widget, key, str(value) )

